#if !defined( _JComplex_h )
#define _JComplex_h

#include "JString.h"
#include "complex.h"

class
#include "JBase.hpp"
JComplex : public JObject {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    static JString toJString(const complex& c);
    static JString toJStringH(const complex& c);
    static JString toJStringF(const complex& c, int w=7, int f=5);
    static complex parse(JString s);
    virtual const char* className() const;
    virtual int hashCode() const;
    virtual JObject* clone() const;
    virtual int compareTo(const JObject& s) const;
    JComplex();
    JComplex(const complex& _value);
    JComplex(JString s);
    operator complex&();
    JString toJString();
  private:
    complex value;
};

#endif
